function [utip]=cookstress_had
    % Parameters:
    E=1;
    magn=1;
    graphics=true;
    nu=1/3;
    convutip=23.97;
    bkgh=9;
    fs={...
        'curve 1 line 0 0 48 44 ',...
        'curve 2 line 48 44 48 52',...
        'curve 3 line 48 52 48 60',...
        'curve 4 line 48 60 0 44',...
        'curve 5 line 0 44 0 0',...
        ['subregion 1  property 1 boundary  1  2 3 4 5']
        };
    utip=[];
    Targetnel=  500;
    
    
    [fens,gcells,groups,edge_gcells,edge_groups]=targe2_mesher(cat(2,fs,{['m-ctl-point constant ' num2str(bkgh)]}), 1.0);
    
    for Adapt=1:14
        
        %     mesh{1}=fens;
        %     mesh{2}=gcells;
        %     drawmesh(mesh); view(2); pause (1)
        %     Material
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_ss_linel_biax (struct('property',prop, ...
            'reduction','stress'));
        % Finite element block
        feb = feblock_defor_ss(struct ('mater',mater, 'gcells',gcells, 'integration_rule',tri_rule(1)));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
        % Define the displacement field
        u   = clone(geom,'u');
        u   = u*0; % zero outfunction five
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0, 44],'inflate',44/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);
        % Number equations
        u   = numbereqns (u);
        % Assemble the system matrix
        K = start (sparse_sysmat, get(u, 'neqns'));
        K = assemble (K, stiffness(feb, geom, u));
        % Load
        F = sysvec;
        F = start (F, get(u, 'neqns'));
        tol=0.00001*44;
        nl=fenode_select (fens,struct ('box',[48,48,44,60],'inflate',tol));
        ni=length(nl)-1;
        for i=1:length(nl)
            F = assemble (F, loads(nodal_load(struct('id',nl(i),'dir',2,'magn',magn/ni/2)), u));
        end
        nl=fenode_select (fens,struct ('box',[48,48,44+10*tol,60-10*tol],'inflate',tol));
        for i=1:length(nl)
            F = assemble (F, loads(nodal_load(struct('id',nl(i),'dir',2,'magn',magn/ni/2)), u));
        end
        % Solve
        u = scatter_sysvec(u, K\F);
        nl=fenode_select (fens,struct ('box',[48,48,52,52],'inflate',100*tol));
        theutip=gather(u,nl,'values');
        disp (['displacement =' num2str(theutip(2))])
        utip =[utip theutip(2)];
        
        nodal_stress = field_from_integration_points(feb, geom, u, [], 'Cauchy', 1:3);
        errors = error_elementwise (feb, geom, u, [], nodal_stress);
        elerrs=sqrt(sum(errors));
        targeterr=sqrt(sum(elerrs.^2)/Targetnel);
        
        x=zeros(length(fens),2);
        for j=1:length(fens)
            x(j,:)=get(fens(j),'xyz');
        end
        hcurs=zeros(length(fens),1)+Inf;
        hests=zeros(length(fens),1)+Inf;
        for j=1:length(gcells)
            conn=get(gcells(j),'conn');
            V=x(conn(2),:)-x(conn(1),:);
            W=x(conn(3),:)-x(conn(1),:);
            A=(V(1)*W(2)-V(2)*W(1))/2;
            hcur=sqrt(A*4/sqrt(3));
            errcur=elerrs(j);
            hest=hcur*(targeterr/errcur);
            for k=1:length(conn)
                hcurs(conn(k))=min([hcurs(conn(k)),hcur]);
                hests(conn(k))=min([hests(conn(k)),hest]);
            end
        end
        
        % Plot
        if graphics
            
            % % Plot
            gv=graphic_viewer;
            gv=reset (gv,struct('limits', [0,48,0,90]));
            cmap=cadcolors;
            nvals=sqrt(sum(errors));
            dcm=data_colormap(struct ('range',[min(nvals),max(nvals)], 'colormap',cmap));%[min(nvals),max(nvals)]
            for i=1:length(gcells)
                color = map_data (dcm, nvals(i));
                draw(gcells(i), gv, struct ('x',geom,'u', u, 'facecolor',color));
            end
            view (2)
            lighting  none;
            nvalsrange=[min(nvals),max(nvals)];
            cbh=colorbar;
            set(cbh,...
                'Position',[0.8 0.15 0.05 0.7],...
                'YLim',[0,1],...
                'YTick',[0,1],...
                'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
            set(get(cbh,'XLabel'),'String',['Error']);
        end
        
        [fens,gcells,groups,edge_gcells,edge_groups] = targe2_mesher_adapt(cat(2,fs,{['m-ctl-point constant ' num2str(min(hests))]}),hcurs,hests,x, 1.0);
        
    end
end