% Automatic graded triangulation of a general 2-D domain. 
%
% function [fens,gcells,groups,edge_gcells,edge_groups] = targe2_mesher_adapt(fs,hcurs,hests,x,thickness,varargin)
%
% See targe2_mesher() documentation for the input and output arguments.
% 
% Additionally:
% hcurs-Current mesh sizes at the locations x
% hests-Desired mesh sizes at the locations x
% x-Array of locations at which mesh sizes are given. The same number of 
%      rows as there are mesh sizes in the above arrays, two coordinates 
%      per row.
% 
%
function [fens,gcells,groups,edge_gcells,edge_groups] = targe2_mesher_adapt(fs,hcurs,hests,x,thickness,varargin)
    for j=1:length(hests)
        s=['m-ctl-point ' num2str(j) ' xy ' num2str(x(j,:)) ' near ' num2str(hests(j)) ' influence ' num2str(hcurs(j)/5)];
        fs{end+1}=s;
    end 
    [fens,gcells,groups,edge_gcells,edge_groups] = targe2_mesher(fs,thickness,varargin{:});
end

